'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = initUpdateState;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var errData = {
  source: 'update_state',
  fragment: null,
  slot: null
};

function initUpdateState(routes, getRouteNameFromResource, getAdditionalState) {
  if (typeof getRouteNameFromResource !== 'function') {
    throw new _appManagerError2.default('You must provide a way to derive the route name from the current resource.', (0, _extends3.default)({}, errData, {
      level: _constants.levels.ERROR,
      code: 'invalid_options',
      recoverable: false
    }));
  }

  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(browserState, currentRoute) {
      var resource, eventTitle, routeName, additionalState;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              resource = browserState.resource, eventTitle = browserState.eventTitle;

              if (resource) {
                _context.next = 3;
                break;
              }

              throw new _appManagerError2.default('No resource provided.', (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'no_resource_provided',
                recoverable: false
              }));

            case 3:
              routeName = null;
              _context.prev = 4;
              _context.next = 7;
              return getRouteNameFromResource(resource);

            case 7:
              routeName = _context.sent;
              _context.next = 13;
              break;

            case 10:
              _context.prev = 10;
              _context.t0 = _context['catch'](4);
              throw new _appManagerError2.default(_context.t0, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'get_route_name_from_location',
                recoverable: false
              }));

            case 13:
              if (!(!routeName || !routes[routeName])) {
                _context.next = 15;
                break;
              }

              return _context.abrupt('return', null);

            case 15:
              additionalState = {};

              if (!(typeof getAdditionalState === 'function')) {
                _context.next = 26;
                break;
              }

              _context.prev = 17;
              _context.next = 20;
              return getAdditionalState(routeName, resource);

            case 20:
              additionalState = _context.sent;
              _context.next = 26;
              break;

            case 23:
              _context.prev = 23;
              _context.t1 = _context['catch'](17);
              throw new _appManagerError2.default(_context.t1, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'get_additional_state',
                recoverable: false
              }));

            case 26:
              return _context.abrupt('return', (0, _extends3.default)({}, additionalState, {
                event: eventTitle && typeof eventTitle === 'string' ? eventTitle : null,
                resource: resource,
                initialRender: !currentRoute,
                prevRoute: currentRoute || null,
                route: routes[routeName]
              }));

            case 27:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[4, 10], [17, 23]]);
    }));

    function updateState(_x, _x2) {
      return _ref.apply(this, arguments);
    }

    return updateState;
  }();
}